//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Threading;

namespace ProfilingSamples
{
	public class ExceptionMain 
	{
		private void ThrowException()
		{
			throw new ApplicationException("Throwing an exception from RecurseException");
		}
		private void ExceptionThread()
		{
			try
			{
				while(true)
				{
					try
					{
						ThrowException();
					}
					catch(ApplicationException)
					{
						TimeSpan ts = new TimeSpan(Environment.TickCount);
						Console.WriteLine("{0}", ts.ToString());
					}
					// Every half a second I throw an exception.
					Thread.Sleep(500);
				}
			}
			catch(Exception e)
			{
				Console.WriteLine("RecurseExceptionThread aborting: {0}", e.Message);
			}
		}
		private void TestThread()
		{
			Thread re = new Thread(new ThreadStart(ExceptionThread));
			try
			{
				re.Start();
				Thread.Sleep(Timeout.Infinite);
			}
			catch(Exception e)
			{
				Console.WriteLine("TestThread aborting: {0}", e.Message);
				re.Abort();
			}
		}
		static void Main(string [] args)
		{
			ExceptionMain m = new ExceptionMain();
			Thread testThread = new Thread(new ThreadStart(m.TestThread));
			testThread.Start();
			string input = Console.ReadLine();
			testThread.Abort();
			testThread.Join();
		}
	}
}