//
// Copyright (c) 2002
// Ronald Kevin Burton
//
// This material is provided "as is", with absolutely no warranty expressed
// or implied. This software is provided solely as part of ".NET Common Language
// Runtime Unleashed" to help illustrate concepts and principles described in 
// that book. Any use is at your own risk.
//
// Permission to use or copy this software for any purpose is hereby granted 
// without fee, provided the above notices are retained on all copies.
// Permission to modify the code and to distribute modified code is granted,
// provided the above notices are retained, and a notice that the code was
// modified is included with the above copyright notice.
//
// 
using System;
using System.Threading;

namespace ProfilingSamples
{
	public class GCPinnedMain 
	{
		private ManualResetEvent asyncEvent;
		unsafe void PinnedThread()
		{
			byte [] ba1 = new byte[100];
			byte [] ba2 = new byte[100];
			byte [] ba3 = new byte[100];
			byte [] ba4 = new byte[100];
			for(int i = 0; i < ba1.Length; i++)
			{
				ba1[i] = (byte)(i % 256);
				ba2[i] = (byte)(i % 256);
				ba3[i] = (byte)(i % 256);
				ba4[i] = (byte)(i % 256);
			}
			fixed(byte *p1 = ba1,p2 = ba2, p3 = ba3, p4 = ba4)
			{
				asyncEvent.WaitOne();
			}
		}
		void TestThread()
		{
			Thread t;
			asyncEvent = new ManualResetEvent(false);
			try
			{
				while(true)
				{
					asyncEvent.Reset();
					t = new Thread(new ThreadStart(PinnedThread));
					t.Start();

					Thread.Sleep(500);

					// Performing a GC promotes the object's generation
					GC.Collect();

					asyncEvent.Set();
					t.Join();

					Thread.Sleep(500);
					// Performing a GC promotes the object's generation
					GC.Collect();

					Thread.Sleep(500);
				}
			}
			catch(Exception e)
			{
				Console.WriteLine("TestThread aborting: {0}", e.Message);
			}
		}
		static void Main(string [] args)
		{
			GCPinnedMain m = new GCPinnedMain();
			Thread testThread = new Thread(new ThreadStart(m.TestThread));
			testThread.Start();
			string input = Console.ReadLine();
			testThread.Abort();
			testThread.Join();
		}
	}
}